<template>
	<view class="content">

		<view @click="echarts.onClick" :prop="option" :change:prop="echarts.updateEcharts" id="echarts2" class="echarts"></view>

	</view>
</template>

<script>
	let echartData = [{
			name: "报警",
			value: 1000
		},
		{
			name: "事件",
			value: 2920
		},
		{
			name: "隐患",
			value: 2200
		},

	];
	let title = '总数';
	let total = echartData.reduce((a, b) => {
		return a + b.value * 1
	}, 0);

	export default {
		data() {
			return {


				option: {

					title: {
						left: 'center'
					},
					tooltip: {
						trigger: 'item',
						formatter: "{a} <br/>{b}: {c} ({d}%)"
					},
					title: [{ //aa标题
						text: '{val|' + total + '}\n{name|' + title + '}',
						top: '45%',
						left: 'center',
						textStyle: {
							rich: {
								name: {
									fontSize: 14,
									fontWeight: 'normal',
									color: '#666666',
									padding: [5, 0]
								},
								val: {
									fontSize: 24,
									color: '#333333',
								}
							}
						}
					}],
					legend: { //aa图例
						orient: 'horizontal',
						icon: 'circle',
						itemWidth: 12,
						itemHeight: 12,
						itemGap: 60,
						// top: -10,
						textStyle: {

							fontSize: 14,
							rich: {
								name: {
									fontSize: 18
								},
								value: {
									fontSize: 14,
									padding: [0, 20, 0, 5]
								},

							}
						},
					},
					color: ['#F67F32', '#3BD2BD', '#1DABFE'],
					series: [{
						name: '访问来源',
						type: 'pie',
						radius: ['40%', '60%'],
						center: ['50%', '55%'],
						itemStyle: {
							normal: {

								shadowBlur: 20,
								shadowColor: '#F9F5F7',
								shadowOffsetX: 0,
								shadowOffsetY: 0,


							},
						},

						data: echartData,
						emphasis: {
							itemStyle: {
								shadowBlur: 10,
								shadowOffsetX: 0,
								shadowColor: 'rgba(0, 0, 0, 0.5)'
							}
						}
					}]
				}
			}
		},
		onLoad() {

		},
		methods: {
			changeOption() {
				const data = this.option.series[0].data
				// 随机更新示例数据
				data.forEach((item, index) => {
					data.splice(index, 1, Math.random() * 40)
				})
			},
			onViewClick(options) {
				console.log(options)
			}
		}
	}
</script>

<script module="echarts" lang="renderjs">
	let myChart
	export default {
		mounted() {
			if (typeof window.echarts === 'function') {
				this.initEcharts()
			} else {
				// 动态引入较大类库避免影响页面展示
				const script = document.createElement('script')
				// view 层的页面运行在 www 根目录，其相对路径相对于 www 计算
				script.src = 'static/echarts.js'
				script.onload = this.initEcharts.bind(this)
				document.head.appendChild(script)
			}
		},
		methods: {
			initEcharts() {
				myChart = echarts.init(document.getElementById('echarts2'))
				// 观测更新的数据在 view 层可以直接访问到
				myChart.setOption(this.option)
			},
			updateEcharts(newValue, oldValue, ownerInstance, instance) {
				// 监听 service 层数据变更
				myChart.setOption(newValue)
			},
			onClick(event, ownerInstance) {
				// 调用 service 层的方法
				ownerInstance.callMethod('onViewClick', {
					test: 'test'
				})
			}
		}
	}
</script>

<style>
	.content {
		display: flex;
		flex-direction: column;
		align-items: center;
		justify-content: center;
	}

	.echarts {
		width: 100%;
		height: 500rpx;
		margin-top: 70rpx;
	}
</style>
